#!/usr/bin/python

from person                      import Person
from distribution_source_package import DistributionSourcePackage

# Distribution
#
class Distribution(object):
    # __init__
    #
    def __init__(self, service, lp_distribution):
        self.__service = service
        self.__lp_distribution = lp_distribution
        self.__owner        = None
        self.__display_name = None

    # __str__
    #
    def __str__(self):
        return self.display_name

    # owner
    #
    @property
    def owner(self):
        if self.__owner == None:
            self.__owner = Person(None, self.__lp_distribution.owner)
        return self.__owner

    # display_name
    #
    @property
    def display_name(self):
        if self.__display_name == None:
            self.__display_name = self.__lp_distribution.display_name
        return self.__display_name

    # get_source_package
    #
    def get_source_package(self, source_pkg):
        return DistributionSourcePackage(self.__service, self.__lp_distribution.getSourcePackage(name = source_pkg))

# vi:set ts=4 sw=4 expandtab:
